﻿@model webUI.SICO.Models.VoucherViewModel

@{
    /**/

    ViewBag.Title = "Buscar Comprobante";
}

<style type="text/css">
    .true {
        color: black;
    }

    .false {
        color: red;
    }
</style>

<div class="row">
    <div class="col-md-12">
        <section class="block">
            <div class="block-header">
                <h3 class="block-title">@ViewBag.Title</h3>
                <div class="block-options">
                    <a href="../Home/Index/" class="btn btn-sm btn-secondary"><span class="fa fa-arrow-left"></span> Atr&aacute;s...</a>
                    <button type="button" class="btn btn-sm btn-success" onclick="fnSearchFirst()"><span class="fa fa-search"></span> Buscar</button>
                    <button type="button" class="btn btn-sm btn-warning" onclick="fnClear()"><span class="fa fa-eraser"></span> Limpiar</button>
                    <button type="button" class="btn-block-option" data-toggle="block-option" data-action="content_toggle"></button>
                </div>
            </div>
            <div class="block-content">
                <div class="container">
                    <div class="row">
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="selType" class="example-text-input-sm">Tipo de Comprobante</label>
                                <select Id="selType" class="form-control form-control-sm"></select>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="txtVoucherId" class="example-text-input-sm">C&oacute;digo</label>
                                <input type="text" class="form-control form-control-sm" id="txtVoucherId">
                            </div>

                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="dtDateIni" class="example-text-input-sm">Fecha Inicial</label>
                                <input type="date" id="dtDateIni" name="dtDateIni" value="@DateTime.Today.ToString("yyyy-MM-dd")" class="form-control form-control-sm" placeholder="dd/mm/yyyy">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group">
                                <label for="dtDateFin" class="example-text-input-sm">Fecha Final</label>
                                <input type="date" id="dtDateFin" name="dtDateFin" value="@DateTime.Today.ToString("yyyy-MM-dd")" class="form-control form-control-sm" placeholder="dd/mm/yyyy">
                            </div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="txtBeneficiary" class="example-text-input-sm">Beneficiario</label>
                                <input type="text" class="form-control form-control-sm" id="txtBeneficiary">
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label for="txtConcept" class="example-text-input-sm">Concepto</label>
                                <input type="text" class="form-control form-control-sm" id="txtConcept">
                            </div>
                        </div>
                    </div>
                </div>                
            </div>
        </section>
    </div>
</div>



<div class="row" id="cdDetalle">
    <div class="col-md-12">
        <div class="block block-bordered" id="bl-detail">            
            <div class="block-content">
                <div class="table-responsive">
                    <table id="detail" class="table table-bordered table-striped table-vcenter">
                        <thead class="cf">
                            <tr>
                                <th width="60">C&oacute;digo</th>
                                <th width="100">Tipo Comprobante</th>
                                <th width="50">Fecha</th>
                                <th width="50%">Beneficiario</th>
                                <th width="40">Opciones</th>
                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>

                </div>
            </div>            
        </div>
    </div>
</div>


@section Scripts {
    <script type="text/javascript">

        var _typeSelected = {};
        _typeSelected.Code = "";
        _typeSelected.Text = "";
        var _attached_info = [];
        var _counter = 0;
        var _debit = 0;
        var _credit = 0;
        var _more = false;
        var _totalRow = 0;


        $("#selType").change(function () {
            
            if (_typeSelected.Code == "NA") {
                _typeSelected.Code = "";
                _typeSelected.Value = "";
                
            }
            else {
                _typeSelected.Code = $(this).children("option:selected").val();
                _typeSelected.Value = $(this).children("option:selected").text();

            }

        });

        fnGetTypes();
        
        function fnGetTypes() {
            var url = "../VoucherType/GetVoucherTypes";
            $('#selType').empty();
            $('#selType').prepend($('<option></option>').html('Cargando...'));
            $("#selType").prop('disabled', true);
            $.ajax({
                type: "GET",
                data: {},
                url: url,
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error');
                        return false;
                    }
                    else {
                        $("#selType").prop('disabled', false);
                        $('#selType').empty();
                        $('#selType').prepend("<option value='NA' >--Seleccione una opcion--</option>");
                        $.each(data.Info, function (key, value) {
                            $('#selType').prepend("<option value='" + value.Code + "' >" + value.Value + "</option>");
                        });
                    }
                }
            });
        }

        function fnDisableFilter(deshabilitar) {
            $("#txtVoucherId").prop('disabled', deshabilitar);
            $("#dtDateIni").prop('disabled', deshabilitar);
            $("#dtDateFin").prop('disabled', deshabilitar);
            $("#txtBeneficiary").prop('disabled', deshabilitar);
            $("#txtConcept").prop('disabled', deshabilitar);
            $("#selType").prop('disabled', deshabilitar);
        }

        function fnSearchMore() {
            var $tbody = $("#detail tbody")
            One.block('state_loading', '#bl-detail');
            var $last = $tbody.find('tr:last');
            if ($last.is(':first-child')) {
                toastr.error('Solo existe un registro.')
            } else {
                $last.remove()
            }

            fnSearch();
        }

        function fnSearchFirst() {
            One.block('state_loading', '#bl-detail');
            $("#detail tbody").empty();
            _totalRow = 0;
            _lastId = 0;
            _firstId = 0;

            fnSearch();
        }

        function fnSearch() {
            
            var Url = "../Voucher/GetFilteredVouchers";
            var first = 0;
            var last = 0;
            var batchLenght = 0;
            var counter = 0;
            var line = "";
            var param = {};            
            param.VoucherId = $("#txtVoucherId").html();
            param.VoucherTypeId = _typeSelected.Code;
            param.InitialDate = $('#dtDateIni').val();
            param.FinalDate = $('#dtDateFin').val();
            param.Beneficiary = $('#txtBeneficiary').val();
            param.Concept = $('#txtConcept').val();
            fnDisableFilter(true);


            $.ajax({
                url: (Url),
                type: "POST",
                async: false,
                data: '{param:' + JSON.stringify(param) + '}',
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.Type == "E") {
                        toastr.error(data.Message, 'Error');
                        One.block('state_normal', '#bl-detail');
                        return false;
                    }
                    else {
                        counter = 0;
                        batchLenght = data.Info.length;
                        _totalRow = _totalRow + batchLenght;

                        $.each(data.Info, function (key, value) {
                            if (counter == 0) {
                                first = value.VoucherId;
                            }
                                                        
                            line = "";
                            line = "<tr class='" + value.IsActive + "'><td>" + value.VoucherId + "</td><td>" + value.VoucherTypeId + "</td><td>" + value.VoucherDatestr + "</td><td>" + "Pendiente BENEFICIARIO" + "</td><td>";
                            line = line + "<a href='../Voucher/Details/" + value.VoucherId + "/' class='btn btn-sm btn-primary'>";
                            line = line + "<span class='fa fa-eye'></span></a>";
                            line = line + "</td></tr>";
                            $("#detail tbody").append(line);
                            last = value.VoucherId;
                            counter++;
                        });
                        _lastId = last;


                        if (batchLenght > 0) {
                            $("#detail tbody").append("<tr><td colspan=5>" + "<button id='btnBack'  onclick='fnSearchMore()' class='btn btn-sm btn-secondary'><span class='fa fa-plus'></span> Mostrar m&aacute;s...</button>" + "</td></tr>");
                            _more = true;
                        }
                        else {
                            _more = false;
                        }
                        fnDisableFilter(false);
                        One.block('state_normal', '#bl-detail');
                    }
                },
                error: function (result) {
                    toastr.error('Se produjo un error inesperado', 'Error');
                    One.block('state_normal', '#bl-detail');
                }
            });

    
        }

        function fnClear() {
            location.reload(true);
        }

        function fnAdd() {

            if (fnValidateDetails()) {
                fnAddDetail();
                $('#txtAccount').focus();
            }

        }


    </script>

    @Scripts.Render("~/bundles/jqueryval")
}
